package org.siprop.android;

import java.util.List;

import org.siprop.android.util.TwitterToken;

import twitter4j.Status;
import twitter4j.Tweet;
import twitter4j.Twitter;
import twitter4j.TwitterException;
import twitter4j.TwitterFactory;
import twitter4j.http.AccessToken;
import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;

/**
 * ツイートを表示するアクティビティ
 * 
 * @author hirotaka@siprop.org
 *
 */
public class LocationActivity extends Activity {

	Tweet tweet;
	List <Status> replyList;
	private final static String TWITLALO_HASH_TAG = "#twitlalo";

	@Override
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.location);

        // 要素の取得
        EditText editText =  (EditText) this.findViewById(R.id.MessageEdit);
        ImageView userImage =  (ImageView) this.findViewById(R.id.UserImage);
        TextView userView = (TextView) this.findViewById(R.id.UserView);
        TextView udpateView = (TextView) this.findViewById(R.id.TweetUpdate);
        Button replyButton = (Button)this.findViewById(R.id.ReplyButton);
        Button retweetButton = (Button)this.findViewById(R.id.RetweetButton);
		TableLayout retweetTable = (TableLayout) this.findViewById(R.id.RetweetTable);

        // Activityから取得
        Intent intent = getIntent();
		Bitmap userBitmap = (Bitmap)intent.getParcelableExtra("userimage");
        tweet = (Tweet)intent.getSerializableExtra("tweet");


		// 各種設定
		String message = tweet.getText().replaceAll(" " + TWITLALO_HASH_TAG, "");
		userImage.setImageBitmap(userBitmap);
		editText.setText(message);
		userView.setText(tweet.getFromUser());
		udpateView.setText(tweet.getCreatedAt().toLocaleString());

        try {
            Twitter twitter = new TwitterFactory().getOAuthAuthorizedInstance(
            		new AccessToken(TwitterToken.getToken(), TwitterToken.getTokenSecret()));

            // retweetを取得する
			replyList = twitter.getRetweets(tweet.getId());
			if (replyList != null && !replyList.isEmpty()) {
				
				TableRow retweetRow = new TableRow(this);
				TextView retweetTitle = new TextView(this);
				retweetTitle.setText("リツイートしたユーザ");
				retweetTitle.setTextColor(Color.BLACK);
				retweetRow.addView(retweetTitle);
				retweetTable.addView(retweetRow);
				
				for (Status status : replyList) {
					TableRow retweetUserRow = new TableRow(this);

					TextView userName = new TextView(this);
					userName.setText(status.getUser().getName() + "さん");
					userName.setTextColor(Color.BLACK);
					userName.setPadding(10, 2, 2, 2);

					TextView updateDate = new TextView(this);
					updateDate.setText(status.getCreatedAt().toLocaleString());
					updateDate.setTextColor(Color.BLACK);
					updateDate.setPadding(5, 2, 2, 2);
					
					retweetUserRow.addView(userName);
					retweetUserRow.addView(updateDate);
					retweetTable.addView(retweetUserRow);
				}
			}
		} catch (TwitterException e) {
			e.printStackTrace();
		}

        replyButton.setOnClickListener(new OnClickListener() {
        	@Override
        	public void onClick(View view) {
        		replyButtonOnClick();
        	}
        });

        retweetButton.setOnClickListener(new OnClickListener() {
        	@Override
        	public void onClick(View view) {
        		retweetButtonOnClick();
        	}
        });

	}
	
    private void replyButtonOnClick() {
    	EditText mssageEdit = (EditText) this.findViewById(R.id.MessageEdit);
    	Intent intent = new Intent(LocationActivity.this, TwitLalo.class);
        intent.putExtra("message", mssageEdit.getText().toString());
        intent.putExtra("tweet", tweet);
        intent.putExtra("type", "REPLY");
        setResult(RESULT_OK, intent);
    	this.finish();
    }

    private void retweetButtonOnClick() {
    	EditText mssageEdit = (EditText) this.findViewById(R.id.MessageEdit);
    	Intent intent = new Intent(LocationActivity.this, TwitLalo.class);
        intent.putExtra("message", mssageEdit.getText().toString());
        intent.putExtra("tweet", tweet);
        intent.putExtra("type", "RETWEET");
        setResult(RESULT_OK, intent);
    	this.finish();
    }
}
