package org.siprop.android.overlay;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Point;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.Projection;

/**
 * 地図上のオーバーレイ
 * 
 * @author hirotaka@siprop.org
 *
 */
public class MapViewOverlay extends Overlay {
	
	GeoPoint geoPoint;
	
	@Override
	public boolean onTap(GeoPoint geoPoint, MapView mapView)  {
		this.geoPoint = geoPoint;
		return super.onTap(geoPoint, mapView);
	}
	
	@Override
	public void draw(Canvas canvas, MapView mapView, boolean shadow) {
        Bitmap bmp = BitmapFactory.decodeResource(mapView.getResources(),
        			android.R.drawable.presence_online);
		super.draw(canvas, mapView, shadow);
        if (!shadow) {
			// 取得したGeoPointを使って、アイコンを描画する。
            Projection projection = mapView.getProjection();
            Point point = new Point();
            if (this.geoPoint == null) this.geoPoint = mapView.getMapCenter();
            projection.toPixels(this.geoPoint, point);
            point.offset(0 - bmp.getWidth()/2, 0 - bmp.getHeight()/2);
            canvas.drawBitmap(bmp, point.x, point.y, null);
        }
	}

	public GeoPoint getGeoPoint() {
		return geoPoint;
	}
	
	
}
