package org.siprop.android.overlay;

import twitter4j.Tweet;

import android.graphics.drawable.Drawable;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.OverlayItem;

/**
 * ツイート情報を保持するアイテム
 * 
 * @author hirotaka@siprop.org
 *
 */
public class TweetOverlayItem extends OverlayItem {

	Tweet tweet;
	
	public TweetOverlayItem(GeoPoint point,
            	java.lang.String title,
            	java.lang.String snippet,
            	Tweet tweet) {
		super(point, title, snippet);
		this.tweet = tweet;
	}
	
	@Override
	public void setMarker(Drawable marker) {
		super.setMarker(marker);
	}

	public long getId() {
		if (this.tweet != null)
			return this.tweet.getId();
		return 0;
	}

	public Tweet getTweet() {
		return tweet;
	}


	public void setTweet(Tweet tweet) {
		this.tweet = tweet;
	}


}
